
%define aprver 0

Summary: Apache Portable Runtime library
Name: apr
Version: 0.9.5
Release: 0.4
License: Apache Software License
Group: System Environment/Libraries
URL: http://apr.apache.org/
Source0: %{name}-%{version}.tar.gz
Source1: LICENSE
Patch0: apr-0.9.3-deplibs.patch
Patch1: apr-0.9.3-config.patch
Patch2: apr-0.9.3-testrand.patch
Patch3: apr-0.9.3-noipv6.patch
Patch4: apr-0.9.5-apr-config.patch
Patch5: apr-0.9.4-tempdir.patch
Patch6: apr-0.9.4-gniv4map.patch
Patch7: apr-0.9.4-cleanups.patch
Patch8: apr-0.9.4-time2038.patch


BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildPrereq: autoconf, libtool, doxygen
Conflicts: subversion < 0.20.1-2

%description
The mission of the Apache Portable Runtime (APR) is to provide a
free library of C data structures and routines, forming a system
portability layer to as many operating systems as possible,
including Unices, MS Win32, BeOS and OS/2.

%package devel
Group: Development/Libraries
Summary: APR library development kit
Requires: apr = %{version}, libtool
Conflicts: subversion-devel < 0.20.1-2

%description devel
This package provides the support files which can be used to 
build applications using the APR library.  The mission of the
Apache Portable Runtime (APR) is to provide a free library of 
C data structures and routines.

%prep
%setup -q
%patch0 -p1 -b .deplibs
%patch1 -p1 -b .config
%patch2 -p1 -b .testrand
%patch3 -p1 -b .noipv6


# Fix apr-config to allow apache build.
%patch4 -p0 -b .apr-config
%patch5 -p1 -b .tempdir
%patch6 -p1 -b .gniv4map
%patch7 -p1 -b .cleanups
%patch8 -p1 -b .time2038

# regenerate configure script etc.
./buildconf

# fix permissions
chmod 644 include/*.h

%build
# disable setpshared and sem_open, which only work on NPTL kernels
cat > config.cache <<EOF
ac_cv_func_pthread_mutexattr_setpshared=no
ac_cv_func_sem_open=no
EOF
%configure -C \
        --includedir=%{_includedir}/apr-%{aprver} \
        --with-installbuilddir=%{_libdir}/apr/build

# build everything using /usr/bin/libtool
perl -pi -e 's|^LIBTOOL=.*$|LIBTOOL=\$(SHELL) /usr/bin/libtool|' build/apr_rules.mk

make LT_LDFLAGS=-Wc,-pthread %{?_smp_mflags} && make dox

# Run non-interactive tests
cd test && make testall && TZ=PST8PDT ./testall -v || exit 1

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
cp $RPM_SOURCE_DIR/LICENSE .

# These are referenced by apr_rules.mk
for f in make_exports.awk make_var_export.awk; do
    install -m 644 build/${f} $RPM_BUILD_ROOT%{_libdir}/apr/build/${f}
done

install -m 755 build/mkdir.sh $RPM_BUILD_ROOT%{_libdir}/apr/build/mkdir.sh

# Sanitize apr_rules.mk
perl -pi -e "s/^apr_build.*=.*$//;" \
   -e 's|$(apr_builders)|%{_libdir}/apr/build|g' \
   $RPM_BUILD_ROOT%{_libdir}/apr/build/apr_rules.mk

# Move docs to more convenient location
mv docs/dox/html html

# Unpackaged files:
rm -f $RPM_BUILD_ROOT%{_libdir}/apr.exp

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc CHANGES LICENSE 
%{_libdir}/libapr-%{aprver}.so.*

%files devel
%defattr(-,root,root,-)
%doc docs/APRDesign.html docs/canonical_filenames.html
%doc docs/incomplete_types docs/non_apr_programs
%doc --parents html
%{_bindir}/apr-config
%{_libdir}/libapr-%{aprver}.*a
%{_libdir}/libapr-%{aprver}.so
%dir %{_libdir}/apr
%dir %{_libdir}/apr/build
%{_libdir}/apr/build/*
%dir %{_includedir}/apr-%{aprver}
%{_includedir}/apr-%{aprver}/*.h

%changelog
* Fri Feb 06 2004 David Summers <david@summersoft.fay.ar.us> 0.9.5-0.3
- Rebuilt with db4-4.2.52-2.

* Thu Dec 25 2003 David Summers <david@summersoft.fay.ar.us> 0.9.5-0.2
- Fixed apr-config --includedir not to echo extra blank line as it messes up
  the apache 2.0.48 build (httpd-2.0.48).

* Wed Nov 26 2003 David Summers <david@summersoft.fay.ar.us> 0.9.5-0.1
- Updated to apr-0.9.5 (apache 2.0.48).

* Sat Jun 28 2003 David Summers <david@summersoft.fay.ar.us> 0.9.4-0.1
- Ported to apr 0.9.4 (apache 2.0.46).

* Tue May 20 2003 Joe Orton <jorton@redhat.com> 0.9.3-5
- add fix for psprintf memory corruption (CAN-2003-0245)
- remove executable bit from apr_poll.h

* Thu May  1 2003 Joe Orton <jorton@redhat.com> 0.9.3-4
- link libapr against libpthread
- make apr-devel conflict with old subversion-devel
- fix License

* Tue Apr 29 2003 Joe Orton <jorton@redhat.com> 0.9.3-3
- run ldconfig in post/postun

* Tue Apr 29 2003 Joe Orton <jorton@redhat.com> 0.9.3-2
- patch test suite to not care if IPv6 is disabled

* Mon Apr 28 2003 Joe Orton <jorton@redhat.com> 0.9.3-1
- initial build
